from __future__ import division, print_function

import pygame
from pygame.locals import *

import sys

import events
import factory
import settings
import state


class GameWindow(object):
    def __init__(self, screen):
        self.screen = screen
        self.clock = pygame.time.Clock()
        self.state = state.MenuState(self, self.screen)

    def render(self):
        self.state.render()
        pygame.display.flip()

    def run(self):
        ms = self.clock.tick(60)
        delta = ms/1000
        self.state.delta = delta
        
        for event in pygame.event.get():
            if event.type == QUIT:
                sys.exit()
            elif event.type == MOUSEBUTTONDOWN:
                events.push(events.Event("click", event.pos))
            elif event.type == KEYDOWN:
                events.push(events.Event("key", event.key))

        self.render()
        events.clear()

    def change_state(self, state):
        self.state = state
