from __future__ import division, print_function

import pygame

import es


class Drawable(object):
    def __init__(self, surface, layer="fg"):
        self.surface = surface
        self.layer = layer

    def get_image(self):
        return self.surface


class RenderSystem(object):
    def __init__(self, master):
        self.master = master
        self.aspect = es.Aspect(master.world, "rect", "image")

    def run(self):
        screen = self.master.screen
        self.draw_layer("bg", screen)
        self.draw_layer("mg", screen)
        self.draw_layer("fg", screen)

    def draw_layer(self, layer, screen):
        for entity in self.aspect:
            if entity["image"].layer == layer:
                screen.blit(entity["image"].get_image(), entity["rect"])
